/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.smartapplication.charge.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.smartapplication.charge.entity.SmartCharge;
import org.springblade.smartapplication.charge.vo.SmartChargeVO;
import org.springblade.smartapplication.charge.service.ISmartChargeService;
import org.springblade.core.boot.ctrl.BladeController;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2020-10-22
 */
@RestController
@AllArgsConstructor
@RequestMapping("charge/smartcharge")
@Api(value = "", tags = "接口")
public class SmartChargeController extends BladeController {

	private ISmartChargeService smartChargeService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入smartCharge")
	public R<SmartCharge> detail(SmartCharge smartCharge) {
		SmartCharge detail = smartChargeService.getOne(Condition.getQueryWrapper(smartCharge));
		return R.data(detail);
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入smartCharge")
	public R<IPage<SmartCharge>> list(SmartCharge smartCharge, Query query) {
		LambdaQueryWrapper<SmartCharge> queryWrapper = Condition.getQueryWrapper(smartCharge).lambda();
		if(null != smartCharge){
			if(null != smartCharge.getUserName()){
				queryWrapper.like(SmartCharge::getUserName,smartCharge.getUserName());
				smartCharge.setUserName(null);
			}
			if(null != smartCharge.getJackName()){
				queryWrapper.like(SmartCharge::getJackName,smartCharge.getJackName());
				smartCharge.setJackName(null);
			}

		}

		IPage<SmartCharge> pages = smartChargeService.page(Condition.getPage(query),queryWrapper);
		return R.data(pages);
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入smartCharge")
	public R<IPage<SmartChargeVO>> page(SmartChargeVO smartCharge, Query query) {
		IPage<SmartChargeVO> pages = smartChargeService.selectSmartChargePage(Condition.getPage(query), smartCharge);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入smartCharge")
	public R save(@Valid @RequestBody SmartCharge smartCharge) {
		return R.status(smartChargeService.save(smartCharge));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入smartCharge")
	public R update(@Valid @RequestBody SmartCharge smartCharge) {
		return R.status(smartChargeService.updateById(smartCharge));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入smartCharge")
	public R submit(@Valid @RequestBody SmartCharge smartCharge) {
		return R.status(smartChargeService.saveOrUpdate(smartCharge));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(smartChargeService.deleteLogic(Func.toLongList(ids)));
	}


}
